#!/usr/bin/env python
from numpy import *
from numpy.random import rand
from scipy.integrate import dblquad


zf = lambda x, y: x**2 * sin(2*pi*y)
f = lambda x, y: exp(zf(x, y))


# ex. a

exactInt = 1.05177

##########################################################################
#                                                                        #
# TODO: Implementieren Sie hier die accurate deterministische Berechnung #
#       des Integrals mit dblquad                                        #
#                                                                        #
##########################################################################

print('Exakt Resultat: %.10f' % exactInt)


# ex. b

def mcquad(f, N):
    I = 0.0  # integral
    sgmtilde = 0.0

    #########################################################
    #                                                       #
    # TODO: Implementieren Sie hier die Monte-Carlo Methode #
    #                                                       #
    #########################################################

    return I, sgmtilde


N = 1000  # number of test points
I, sgmtilde = mcquad(f, N)

absfehler = 0.0  # nur Platzhalter
relfehler = 0.0  # nur Platzhalter

###############################################################
#                                                             #
# TODO: Berechnen Sie hier den relativen und absoluten Fehler #
#                                                             #
###############################################################

print("N. Probepunkten: %d" % N)
print("Monte Carlo Integral: %f" % I)
print("Konfidenzinterval Radius: %f" % sgmtilde)
print("Absoluter Fehler: %f" % absfehler)
print("Relativer Fehler: %f" % relfehler)


# ex. c

def mcexperiments(f, M, N):

    Imittel = 0.0   # nur Platzhalter
    sgmtilde = 0.0  # nur Platzhalter

    #################################################
    #                                               #
    # TODO: Implementieren Sie hier die Experimente #
    #                                               #
    #################################################

    return Imittel, sgmtilde


M = 100    # number of experiments
N = 10000  # number of test points
Imittel, sgmtilde = mcexperiments(f, M, N)

absfehler = 0.0  # nur Platzhalter
relfehler = 0.0  # nur Platzhalter

###############################################################
#                                                             #
# TODO: Berechnen Sie hier den relativen und absoluten Fehler #
#                                                             #
###############################################################

print("-" * 16)
print("%d Experimenten, %d Probepunkten" % (M, N))
print("Monte Carlo Integral: %f" % Imittel)
print("Konfidenzinterval Radius: %f" % sgmtilde)
print("Absoluter Fehler: %f" % absfehler)
print("Relativer Fehler: %f" % relfehler)


# ex. d

CVMC = 0.0  # nur Platzhalter
sgm2 = 0.0  # nur Platzhalter

##############################################################
#                                                            #
# TODO: Implementieren Sie hier Control Variates Monte-Carlo #
#                                                            #
##############################################################

print("-" * 16)
print("%d Experimenten, %d Probepunkten" % (M, N))
print("Monte Carlo Integral: %f" % CVMC)
print("Konfidenzinterval Radius: %f" % sgm2)
print("Absoluter Fehler: %f" % absfehler)
print("Relativer Fehler: %f" % relfehler)
